//.          GPS module for "Virtual Town"project
//.                  Copyright (c) 2005 
//.                                                       
//.  Authors: PAV <AlxPonom@mail.ru>             
//.                                                       
//.  This program is free software under the GPL (>= v2)  
//.  Read the file COPYING coming with project for details 

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Xml;

namespace GEOGraphServer
{
	using CrdSys;

	/// <summary>
	/// Summary description for GEOGraphUsers.
	/// </summary>
	public class TfmGEOGraphUsers : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox tbUserName;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.TextBox tbUserID;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.TextBox tbUserPassword;
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.TreeView twUsers;
		private System.Windows.Forms.ImageList twUsers_Images;
		private System.Windows.Forms.Panel pnlUser;
		private System.Windows.Forms.Button btnSetSelectedUser;
		private System.Windows.Forms.Panel pnlUserObject;
		private System.Windows.Forms.Button btnSetSelectedUserObject;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox tbObjectCrdSysID;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.TextBox tbObjectID;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.TextBox tbObjectName;
		private System.Windows.Forms.ContextMenu twUsers_ContextMenu;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.Label label10;
		private System.Windows.Forms.TextBox tbObjectidTVisualization;
		private System.Windows.Forms.TextBox tbObjectidVisualization;
		public TGEOGraphUsers Users;

		public TfmGEOGraphUsers(TGEOGraphUsers pUsers)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			//.
			Users = pUsers;
			twUsers_Update();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(TfmGEOGraphUsers));
			this.pnlUser = new System.Windows.Forms.Panel();
			this.label7 = new System.Windows.Forms.Label();
			this.btnSetSelectedUser = new System.Windows.Forms.Button();
			this.label4 = new System.Windows.Forms.Label();
			this.tbUserPassword = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.tbUserID = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.tbUserName = new System.Windows.Forms.TextBox();
			this.twUsers = new System.Windows.Forms.TreeView();
			this.twUsers_ContextMenu = new System.Windows.Forms.ContextMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.twUsers_Images = new System.Windows.Forms.ImageList(this.components);
			this.pnlUserObject = new System.Windows.Forms.Panel();
			this.label10 = new System.Windows.Forms.Label();
			this.tbObjectidVisualization = new System.Windows.Forms.TextBox();
			this.label9 = new System.Windows.Forms.Label();
			this.tbObjectidTVisualization = new System.Windows.Forms.TextBox();
			this.label8 = new System.Windows.Forms.Label();
			this.btnSetSelectedUserObject = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.tbObjectCrdSysID = new System.Windows.Forms.TextBox();
			this.label5 = new System.Windows.Forms.Label();
			this.tbObjectID = new System.Windows.Forms.TextBox();
			this.label6 = new System.Windows.Forms.Label();
			this.tbObjectName = new System.Windows.Forms.TextBox();
			this.pnlUser.SuspendLayout();
			this.pnlUserObject.SuspendLayout();
			this.SuspendLayout();
			// 
			// pnlUser
			// 
			this.pnlUser.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.pnlUser.Controls.Add(this.label7);
			this.pnlUser.Controls.Add(this.btnSetSelectedUser);
			this.pnlUser.Controls.Add(this.label4);
			this.pnlUser.Controls.Add(this.tbUserPassword);
			this.pnlUser.Controls.Add(this.label3);
			this.pnlUser.Controls.Add(this.tbUserID);
			this.pnlUser.Controls.Add(this.label2);
			this.pnlUser.Controls.Add(this.tbUserName);
			this.pnlUser.Location = new System.Drawing.Point(240, 8);
			this.pnlUser.Name = "pnlUser";
			this.pnlUser.Size = new System.Drawing.Size(192, 208);
			this.pnlUser.TabIndex = 6;
			this.pnlUser.Visible = false;
			// 
			// label7
			// 
			this.label7.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.label7.Location = new System.Drawing.Point(48, 0);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(69, 16);
			this.label7.TabIndex = 11;
			this.label7.Text = "user";
			this.label7.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// btnSetSelectedUser
			// 
			this.btnSetSelectedUser.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.btnSetSelectedUser.Location = new System.Drawing.Point(64, 168);
			this.btnSetSelectedUser.Name = "btnSetSelectedUser";
			this.btnSetSelectedUser.Size = new System.Drawing.Size(64, 32);
			this.btnSetSelectedUser.TabIndex = 10;
			this.btnSetSelectedUser.Text = "Set";
			this.btnSetSelectedUser.Click += new System.EventHandler(this.btnSetSelectedUser_Click);
			// 
			// label4
			// 
			this.label4.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.label4.Location = new System.Drawing.Point(11, 125);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(69, 16);
			this.label4.TabIndex = 6;
			this.label4.Text = "password";
			this.label4.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// tbUserPassword
			// 
			this.tbUserPassword.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.tbUserPassword.Location = new System.Drawing.Point(80, 121);
			this.tbUserPassword.Name = "tbUserPassword";
			this.tbUserPassword.PasswordChar = '*';
			this.tbUserPassword.Size = new System.Drawing.Size(64, 23);
			this.tbUserPassword.TabIndex = 5;
			this.tbUserPassword.Text = "";
			// 
			// label3
			// 
			this.label3.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.label3.Location = new System.Drawing.Point(11, 75);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(46, 16);
			this.label3.TabIndex = 4;
			this.label3.Text = "ID";
			this.label3.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// tbUserID
			// 
			this.tbUserID.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.tbUserID.Location = new System.Drawing.Point(57, 71);
			this.tbUserID.Name = "tbUserID";
			this.tbUserID.Size = new System.Drawing.Size(88, 23);
			this.tbUserID.TabIndex = 3;
			this.tbUserID.Text = "";
			// 
			// label2
			// 
			this.label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.label2.Location = new System.Drawing.Point(10, 28);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(46, 16);
			this.label2.TabIndex = 2;
			this.label2.Text = "name";
			this.label2.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// tbUserName
			// 
			this.tbUserName.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.tbUserName.Location = new System.Drawing.Point(56, 24);
			this.tbUserName.Name = "tbUserName";
			this.tbUserName.Size = new System.Drawing.Size(88, 23);
			this.tbUserName.TabIndex = 0;
			this.tbUserName.Text = "";
			// 
			// twUsers
			// 
			this.twUsers.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.twUsers.ContextMenu = this.twUsers_ContextMenu;
			this.twUsers.Dock = System.Windows.Forms.DockStyle.Left;
			this.twUsers.HideSelection = false;
			this.twUsers.ImageList = this.twUsers_Images;
			this.twUsers.Location = new System.Drawing.Point(0, 0);
			this.twUsers.Name = "twUsers";
			this.twUsers.Size = new System.Drawing.Size(232, 461);
			this.twUsers.TabIndex = 7;
			this.twUsers.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.twUsers_AfterSelect);
			this.twUsers.BeforeSelect += new System.Windows.Forms.TreeViewCancelEventHandler(this.twUsers_BeforeSelect);
			// 
			// twUsers_ContextMenu
			// 
			this.twUsers_ContextMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																								this.menuItem1,
																								this.menuItem2,
																								this.menuItem3});
			this.twUsers_ContextMenu.Popup += new System.EventHandler(this.twUsers_ContextMenu_Popup);
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.Text = "Add new user";
			this.menuItem1.Click += new System.EventHandler(this.menuItem1_Click);
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 1;
			this.menuItem2.Text = "Add object to the user";
			this.menuItem2.Click += new System.EventHandler(this.menuItem2_Click);
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 2;
			this.menuItem3.Text = "Remove";
			this.menuItem3.Click += new System.EventHandler(this.menuItem3_Click);
			// 
			// twUsers_Images
			// 
			this.twUsers_Images.ImageSize = new System.Drawing.Size(16, 16);
			this.twUsers_Images.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("twUsers_Images.ImageStream")));
			this.twUsers_Images.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// pnlUserObject
			// 
			this.pnlUserObject.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.pnlUserObject.Controls.Add(this.label10);
			this.pnlUserObject.Controls.Add(this.tbObjectidVisualization);
			this.pnlUserObject.Controls.Add(this.label9);
			this.pnlUserObject.Controls.Add(this.tbObjectidTVisualization);
			this.pnlUserObject.Controls.Add(this.label8);
			this.pnlUserObject.Controls.Add(this.btnSetSelectedUserObject);
			this.pnlUserObject.Controls.Add(this.label1);
			this.pnlUserObject.Controls.Add(this.tbObjectCrdSysID);
			this.pnlUserObject.Controls.Add(this.label5);
			this.pnlUserObject.Controls.Add(this.tbObjectID);
			this.pnlUserObject.Controls.Add(this.label6);
			this.pnlUserObject.Controls.Add(this.tbObjectName);
			this.pnlUserObject.Location = new System.Drawing.Point(240, 8);
			this.pnlUserObject.Name = "pnlUserObject";
			this.pnlUserObject.Size = new System.Drawing.Size(192, 208);
			this.pnlUserObject.TabIndex = 8;
			this.pnlUserObject.Visible = false;
			// 
			// label10
			// 
			this.label10.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.label10.Location = new System.Drawing.Point(0, 139);
			this.label10.Name = "label10";
			this.label10.Size = new System.Drawing.Size(112, 16);
			this.label10.TabIndex = 16;
			this.label10.Text = "Visualization id";
			this.label10.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// tbObjectidVisualization
			// 
			this.tbObjectidVisualization.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.tbObjectidVisualization.Location = new System.Drawing.Point(112, 135);
			this.tbObjectidVisualization.Name = "tbObjectidVisualization";
			this.tbObjectidVisualization.Size = new System.Drawing.Size(56, 23);
			this.tbObjectidVisualization.TabIndex = 15;
			this.tbObjectidVisualization.Text = "";
			// 
			// label9
			// 
			this.label9.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.label9.Location = new System.Drawing.Point(0, 114);
			this.label9.Name = "label9";
			this.label9.Size = new System.Drawing.Size(112, 16);
			this.label9.TabIndex = 14;
			this.label9.Text = "Visualization type";
			this.label9.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// tbObjectidTVisualization
			// 
			this.tbObjectidTVisualization.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.tbObjectidTVisualization.Location = new System.Drawing.Point(112, 110);
			this.tbObjectidTVisualization.Name = "tbObjectidTVisualization";
			this.tbObjectidTVisualization.Size = new System.Drawing.Size(56, 23);
			this.tbObjectidTVisualization.TabIndex = 13;
			this.tbObjectidTVisualization.Text = "";
			// 
			// label8
			// 
			this.label8.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.label8.Location = new System.Drawing.Point(48, 0);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(69, 16);
			this.label8.TabIndex = 12;
			this.label8.Text = "object";
			this.label8.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// btnSetSelectedUserObject
			// 
			this.btnSetSelectedUserObject.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.btnSetSelectedUserObject.Location = new System.Drawing.Point(56, 168);
			this.btnSetSelectedUserObject.Name = "btnSetSelectedUserObject";
			this.btnSetSelectedUserObject.Size = new System.Drawing.Size(64, 32);
			this.btnSetSelectedUserObject.TabIndex = 10;
			this.btnSetSelectedUserObject.Text = "Set";
			this.btnSetSelectedUserObject.Click += new System.EventHandler(this.btnSetSelectedUserObject_Click);
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.label1.Location = new System.Drawing.Point(11, 80);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(69, 16);
			this.label1.TabIndex = 6;
			this.label1.Text = "CrdSys ID";
			this.label1.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// tbObjectCrdSysID
			// 
			this.tbObjectCrdSysID.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.tbObjectCrdSysID.Location = new System.Drawing.Point(80, 76);
			this.tbObjectCrdSysID.Name = "tbObjectCrdSysID";
			this.tbObjectCrdSysID.Size = new System.Drawing.Size(88, 23);
			this.tbObjectCrdSysID.TabIndex = 5;
			this.tbObjectCrdSysID.Text = "";
			// 
			// label5
			// 
			this.label5.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.label5.Location = new System.Drawing.Point(11, 54);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(46, 16);
			this.label5.TabIndex = 4;
			this.label5.Text = "ID";
			this.label5.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// tbObjectID
			// 
			this.tbObjectID.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.tbObjectID.Location = new System.Drawing.Point(57, 50);
			this.tbObjectID.Name = "tbObjectID";
			this.tbObjectID.ReadOnly = true;
			this.tbObjectID.Size = new System.Drawing.Size(111, 23);
			this.tbObjectID.TabIndex = 3;
			this.tbObjectID.Text = "";
			// 
			// label6
			// 
			this.label6.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.label6.Location = new System.Drawing.Point(10, 28);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(46, 16);
			this.label6.TabIndex = 2;
			this.label6.Text = "name";
			this.label6.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// tbObjectName
			// 
			this.tbObjectName.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.tbObjectName.Location = new System.Drawing.Point(56, 24);
			this.tbObjectName.Name = "tbObjectName";
			this.tbObjectName.Size = new System.Drawing.Size(112, 23);
			this.tbObjectName.TabIndex = 0;
			this.tbObjectName.Text = "";
			// 
			// TfmGEOGraphUsers
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(440, 461);
			this.Controls.Add(this.pnlUserObject);
			this.Controls.Add(this.twUsers);
			this.Controls.Add(this.pnlUser);
			this.Name = "TfmGEOGraphUsers";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Users";
			this.pnlUser.ResumeLayout(false);
			this.pnlUserObject.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void twUsers_Update()
		{
			lock(Users)
			{
				twUsers.Nodes.Clear();
				for (int I = 0; I < Users.List.Count; I++)
				{
					TGEOGraphUser User = (TGEOGraphUser)(Users.List[I]);
					TreeNode UserNode = new TreeNode(User.UserName);
					UserNode.Tag = User.UserID;
					UserNode.ImageIndex = 0;
					UserNode.SelectedImageIndex = UserNode.ImageIndex;
					if (User.Objects != null)
					{
						for (int J = 0; J < User.Objects.Count; J++)
						{
							TGEOGraphUserObject Obj = (TGEOGraphUserObject)User.Objects[J];							
							TreeNode ObjNode = new TreeNode(Obj.ObjectName);
							ObjNode.Tag = Obj.ObjectID;
							ObjNode.ImageIndex = 1;
							ObjNode.SelectedImageIndex = ObjNode.ImageIndex;
							//.
							UserNode.Nodes.Add(ObjNode);
						};
					};
					twUsers.Nodes.Add(UserNode);
					UserNode.Expand();
				};
			};
		}

		private void ShowUserPane(int UserID)
		{
			lock(Users)
			{
				TGEOGraphUser User;
				if (Users.GetUser(UserID, out User))
				{
					tbUserName.Text = User.UserName;
					tbUserID.Text = User.UserID.ToString();
					tbUserPassword.Text = User.UserPassword;
					//.
					pnlUser.BringToFront();
					pnlUser.Show();
				}
				else
				{
					pnlUser.Hide();
				};
			}
		}

		private void ShowObjectPane(int ObjectID)
		{
			lock(Users)
			{
				TGEOGraphUserObject Obj;
				if (Users.GetObject(ObjectID, out Obj))
				{
					tbObjectName.Text = Obj.ObjectName;
					tbObjectID.Text = Obj.ObjectID.ToString();
					tbObjectCrdSysID.Text = Obj.GeoCrdSysID.ToString();
					tbObjectidTVisualization.Text = Obj.idTVisualization.ToString();
					tbObjectidVisualization.Text = Obj.idVisualization.ToString();
					//.
					pnlUserObject.BringToFront();
					pnlUserObject.Show();
				}
				else
				{
					pnlUserObject.Hide();
				};
			}
		}

		private void btnSetSelectedUser_Click(object sender, System.EventArgs e)
		{
			if ((twUsers.SelectedNode == null) || (twUsers.SelectedNode == null)) return; //. ->
			lock(Users)
			{
				TGEOGraphUser User = null;
				if (Users.GetUser((int)twUsers.SelectedNode.Tag, out User))
				{
					User.UserName = tbUserName.Text;
					User.UserID = Convert.ToInt32(tbUserID.Text);
					User.UserPassword = tbUserPassword.Text;
					//.
					Users.Save();
					//.
					twUsers.SelectedNode.Text = User.UserName;
					twUsers.SelectedNode.Tag = User.UserID;
				};
			};
		}

		private void btnSetSelectedUserObject_Click(object sender, System.EventArgs e)
		{
			if ((twUsers.SelectedNode == null) || (twUsers.SelectedNode == null)) return; //. ->
			lock(Users)
			{
				TGEOGraphUserObject Obj = null;
				if (Users.GetObject((int)twUsers.SelectedNode.Tag, out Obj))
				{
					Obj.ObjectName = tbObjectName.Text;
					Obj.ObjectID = Convert.ToInt32(tbObjectID.Text);
					Obj.GeoCrdSysID = Convert.ToInt32(tbObjectCrdSysID.Text);
					Obj.idTVisualization = Convert.ToInt32(tbObjectidTVisualization.Text);
					Obj.idVisualization = Convert.ToInt32(tbObjectidVisualization.Text);
					//.
					Users.Save();
					//.
					twUsers.SelectedNode.Text = Obj.ObjectName;	
				};
			};
		}
		private void twUsers_BeforeSelect(object sender, System.Windows.Forms.TreeViewCancelEventArgs e)
		{
		}

		private void twUsers_AfterSelect(object sender, System.Windows.Forms.TreeViewEventArgs e)
		{
			if (e.Node.Parent == null)
			{
				ShowUserPane((int)e.Node.Tag);
				pnlUserObject.Show();
			}
			else
			{
				ShowObjectPane((int)e.Node.Tag);
			};
		}

		private void menuItem1_Click(object sender, System.EventArgs e)
		{
			TGEOGraphUser NewUser = new TGEOGraphUser();
			NewUser.UserName = "NewUser";
			NewUser.UserID = 0;
			NewUser.UserPassword = "";
			//.
			Users.AddUser(NewUser);
			//. 
			TreeNode NewUserNode = new TreeNode(NewUser.UserName);
			NewUserNode.Tag = NewUser.UserID;
			NewUserNode.ImageIndex = 0;
			NewUserNode.SelectedImageIndex = NewUserNode.ImageIndex;
			twUsers.Nodes.Add(NewUserNode);
			twUsers.SelectedNode = NewUserNode;
		}

		private void menuItem3_Click(object sender, System.EventArgs e)
		{
			if (twUsers.SelectedNode == null) return; //. ->
			if (twUsers.SelectedNode.Parent == null)
			{
				int RemoveUserID = (int)(twUsers.SelectedNode.Tag);
				//.
				Users.RemoveUser(RemoveUserID);
				//.
				twUsers.SelectedNode.Remove();
			}
			else
			{
				int UserID = (int)(twUsers.SelectedNode.Parent.Tag);
				//.
				lock(Users)
				{
					TGEOGraphUser User;
					if (Users.GetUser(UserID, out User) && (User.Objects !=null))
					{
						User.RemoveObjectByID((int)twUsers.SelectedNode.Tag);
						//.
						Users.Save();
						//.
						twUsers.SelectedNode.Remove();
					};
				}
			};
		}

		private void menuItem2_Click(object sender, System.EventArgs e)
		{
			if (twUsers.SelectedNode == null) return; //. ->
			if (twUsers.SelectedNode.Parent == null)
			{
				int UserID = (int)(twUsers.SelectedNode.Tag);
				TGEOGraphUser User;
				lock(Users)
				{
					if (Users.GetUser(UserID, out User))
					{
						TGEOGraphUserObject Obj = new TGEOGraphUserObject();
						Obj.ObjectID = Users.GetNextObjectID();
						Obj.ObjectName = "Object"+Obj.ObjectID.ToString();
						Obj.GeoCrdSysID = 1;
						Obj.idTVisualization = 0;
						Obj.idVisualization = 0;
						User.AddObject(Obj);
						//.
						Users.Save();
						//.
						TreeNode NewObjectNode = new TreeNode(Obj.ObjectName);
						NewObjectNode.Tag = Obj.ObjectID;
						NewObjectNode.ImageIndex = 1;
						NewObjectNode.SelectedImageIndex = NewObjectNode.ImageIndex;
						twUsers.SelectedNode.Nodes.Add(NewObjectNode);
						twUsers.SelectedNode = NewObjectNode;
					};
				};
			}
		}

		private void twUsers_ContextMenu_Popup(object sender, System.EventArgs e)
		{
			if (twUsers.SelectedNode == null) return; //. ->
			if (twUsers.SelectedNode.Parent == null)
			{
				twUsers_ContextMenu.MenuItems[0].Visible = true;
				twUsers_ContextMenu.MenuItems[1].Visible = true;
			}
			else
			{
				twUsers_ContextMenu.MenuItems[0].Visible = false;
				twUsers_ContextMenu.MenuItems[1].Visible = false;
			};
		
		}
	}

	public class TGEOGraphUser
	{
		public int UserID;
		public string UserName;
		public string UserPassword;
		public ArrayList Objects;

		public void AddObject(TGEOGraphUserObject Obj)
		{
			if (Objects == null) Objects = new ArrayList();
			Objects.Add(Obj);
		}
		public void RemoveObjectByID(int ObjectID)
		{
			if (Objects == null) return; //. ->
			for (int I = 0; I < Objects.Count; I++)
			{
				if (((TGEOGraphUserObject)(Objects[I])).ObjectID == ObjectID)
				{
					Objects.RemoveAt(I);
					return; //. ->
				}
			}
		}
	}

	public class TGEOGraphUserObject
	{
		public int ObjectID;
		public string ObjectName;
		public int GeoCrdSysID;
		public int idTVisualization;
		public int idVisualization;
		public TCrdSysConvertor CrdSysConvertor;
		public double X0,Y0, X1,Y1, L;
	}

	public class TGEOGraphUsers
	{
		public string UsersFileName = "Users.xml";
		public ArrayList List;

		public TGEOGraphUsers()
		{
			List = new ArrayList();
			Load();
		}

		public void Clear()
		{
			lock(this)
			{
				List.Clear();
			};
		}

		public void Load()
		{
			lock(this)
			{
				Clear();
				//.
				if (System.IO.File.Exists(UsersFileName))
				{
					XmlDocument XmlDoc = new XmlDocument();
					XmlDoc.Load(UsersFileName);
					XmlNode ListNode = XmlDoc.SelectSingleNode("ROOT");
					for (int I = 0; I < ListNode.ChildNodes.Count; I++)
					{
						XmlNode UserNode = ListNode.ChildNodes[I];
						TGEOGraphUser NewUser = new TGEOGraphUser();
						NewUser.UserName = UserNode.Name;
						NewUser.UserID = Convert.ToInt32(UserNode.SelectSingleNode("ID").InnerText);
						NewUser.UserPassword = UserNode.SelectSingleNode("Password").InnerText;
						XmlNode UserObjectsNode = UserNode.SelectSingleNode("Objects");
						if (UserObjectsNode != null)
						{
							NewUser.Objects = new ArrayList(UserObjectsNode.ChildNodes.Count);
							for (int J = 0; J < UserObjectsNode.ChildNodes.Count; J++)
							{
								XmlNode ObjectNode = UserObjectsNode.ChildNodes[J];
								TGEOGraphUserObject Obj = new TGEOGraphUserObject();
								Obj.ObjectName = ObjectNode.Name;
								Obj.ObjectID = Convert.ToInt32(ObjectNode.SelectSingleNode("ID").InnerText);
								Obj.GeoCrdSysID = Convert.ToInt32(ObjectNode.SelectSingleNode("CrdSysID").InnerText);
								Obj.idTVisualization = Convert.ToInt32(ObjectNode.SelectSingleNode("idTVisualization").InnerText);
								Obj.idVisualization = Convert.ToInt32(ObjectNode.SelectSingleNode("idVisualization").InnerText);
								NewUser.Objects.Add(Obj);
							}
						}
						else
						{
							NewUser.Objects = null;
						};
						List.Add(NewUser);
					};
				};
			};
		}

		public void Save()
		{
			lock(this)
			{
				XmlTextWriter writer = new XmlTextWriter(UsersFileName, System.Text.Encoding.UTF8);
				try
				{
					writer.WriteStartDocument();
					writer.WriteStartElement("ROOT");
					for (int I  = 0; I < List.Count; I++)
					{
						TGEOGraphUser User = (TGEOGraphUser)(List[I]);
						writer.WriteStartElement(User.UserName);
						//. ID
						writer.WriteStartElement("ID");
						writer.WriteString(User.UserID.ToString());
						writer.WriteEndElement();
						//. Password
						writer.WriteStartElement("Password");
						writer.WriteString(User.UserPassword);
						writer.WriteEndElement();
						//. write Objects
						if (User.Objects != null)
						{
							writer.WriteStartElement("Objects");
							for (int J = 0; J < User.Objects.Count; J++)
							{
								TGEOGraphUserObject Obj = (TGEOGraphUserObject)(User.Objects[J]);
								writer.WriteStartElement(Obj.ObjectName);
								//. ID
								writer.WriteStartElement("ID");
								writer.WriteString(Obj.ObjectID.ToString());
								writer.WriteEndElement();
								//. CrdSys ID
								writer.WriteStartElement("CrdSysID");
								writer.WriteString(Obj.GeoCrdSysID.ToString());
								writer.WriteEndElement();
								//. idTVisualization
								writer.WriteStartElement("idTVisualization");
								writer.WriteString(Obj.idTVisualization.ToString());
								writer.WriteEndElement();
								//. idVisualization
								writer.WriteStartElement("idVisualization");
								writer.WriteString(Obj.idVisualization.ToString());
								writer.WriteEndElement();
								//.
								writer.WriteEndElement();
							};
							writer.WriteEndElement();
						};
						//.
						writer.WriteEndElement();
					};
					writer.WriteEndElement();
					writer.WriteEndDocument();
				}
				finally 
				{
					writer.Close();
				};
			};
		}

		public bool GetUser(int pUserID, out TGEOGraphUser User)
		{
			User = null;
			for (int I  = 0; I < List.Count; I++)
			{
				if (((TGEOGraphUser)(List[I])).UserID == pUserID)
				{
					User = ((TGEOGraphUser)(List[I]));
					return true; //. ->
				};
			};
			return false;
		}

		public bool GetUserAndObjectByObjectID(int pObjectID, out TGEOGraphUser User, out TGEOGraphUserObject Object)
		{
			User = null;
			Object = null;
			for (int I  = 0; I < List.Count; I++)
			{
				TGEOGraphUser Usr = (TGEOGraphUser)List[I];
				if (Usr.Objects != null)
				{
					for (int J = 0; J < Usr.Objects.Count; J ++)
					{
						TGEOGraphUserObject Obj = (TGEOGraphUserObject)Usr.Objects[J];
						if (Obj.ObjectID == pObjectID)
						{
							User = Usr;
							Object = Obj;
							return true; //. ->
						};
					};
				};
			};
			return false;
		}

		public bool GetObject(int pObjectID, out TGEOGraphUserObject Object)
		{
			Object = null;
			for (int I  = 0; I < List.Count; I++)
			{
				TGEOGraphUser User = (TGEOGraphUser)List[I];
				if (User.Objects != null)
				{
					for (int J = 0; J < User.Objects.Count; J ++)
					{
						TGEOGraphUserObject Obj = (TGEOGraphUserObject)User.Objects[J];
						if (Obj.ObjectID == pObjectID)
						{
							Object = Obj;
							return true; //. ->
						};
					};
				};
			};
			return false;
		}

		public int GetNextObjectID()
		{
			int Result = 0;
			lock(this)
			{
				for (int I  = 0; I < List.Count; I++)
				{
					TGEOGraphUser User = (TGEOGraphUser)List[I];
					if (User.Objects != null)
					{
						for (int J = 0; J < User.Objects.Count; J ++)
						{
							TGEOGraphUserObject Obj = (TGEOGraphUserObject)User.Objects[J];
							if (Obj.ObjectID > Result) Result = Obj.ObjectID;
						};
					};
				};
			}
			return (Result+1);
		}

		public TGEOGraphUser AddUser(TGEOGraphUser User)
		{
			lock(this)	
			{
				List.Add(User);
			};
			Save();
			return User;
		}

		public void RemoveUser(int pUserID)
		{
			lock(this)
			{
				int I =0;
				while (I < List.Count)
				{
					if (((TGEOGraphUser)(List[I])).UserID == pUserID) List.RemoveAt(I);	else I++;
				};
			};
			Save();
		}
	}

}
