//.          GPS module for "Virtual Town"project
//.                  Copyright (c) 2005 
//.                                                       
//.  Authors: PAV <AlxPonom@mail.ru>             
//.                                                       
//.  This program is free software under the GPL (>= v2)  
//.  Read the file COPYING coming with project for details 

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace GEOGraph
{
	/// <summary>
	/// Summary description for GPSMonitorConfigurationForm.
	/// </summary>
	public class GPSMonitorConfigurationForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox tbCrdSysID;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.TextBox tbUpdatingInterval;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.TextBox tbUserPassword;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.TextBox tbUserName;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.TextBox tbServerURL;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.TextBox tbVisualizationID;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox tbVisualizationTypeID;
		private System.Windows.Forms.Label label1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public GPSMonitorConfigurationForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.tbCrdSysID = new System.Windows.Forms.TextBox();
			this.label7 = new System.Windows.Forms.Label();
			this.tbUpdatingInterval = new System.Windows.Forms.TextBox();
			this.label6 = new System.Windows.Forms.Label();
			this.tbUserPassword = new System.Windows.Forms.TextBox();
			this.label5 = new System.Windows.Forms.Label();
			this.tbUserName = new System.Windows.Forms.TextBox();
			this.label4 = new System.Windows.Forms.Label();
			this.tbServerURL = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.tbVisualizationID = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.tbVisualizationTypeID = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// tbCrdSysID
			// 
			this.tbCrdSysID.Enabled = false;
			this.tbCrdSysID.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.tbCrdSysID.Location = new System.Drawing.Point(292, 110);
			this.tbCrdSysID.Name = "tbCrdSysID";
			this.tbCrdSysID.Size = new System.Drawing.Size(104, 23);
			this.tbCrdSysID.TabIndex = 29;
			this.tbCrdSysID.Text = "";
			// 
			// label7
			// 
			this.label7.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.label7.Location = new System.Drawing.Point(292, 86);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(112, 16);
			this.label7.TabIndex = 28;
			this.label7.Text = "CrdSys ID";
			// 
			// tbUpdatingInterval
			// 
			this.tbUpdatingInterval.Enabled = false;
			this.tbUpdatingInterval.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.tbUpdatingInterval.Location = new System.Drawing.Point(292, 54);
			this.tbUpdatingInterval.Name = "tbUpdatingInterval";
			this.tbUpdatingInterval.Size = new System.Drawing.Size(104, 23);
			this.tbUpdatingInterval.TabIndex = 27;
			this.tbUpdatingInterval.Text = "";
			// 
			// label6
			// 
			this.label6.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.label6.Location = new System.Drawing.Point(292, 30);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(112, 16);
			this.label6.TabIndex = 26;
			this.label6.Text = "Updating interval";
			// 
			// tbUserPassword
			// 
			this.tbUserPassword.Enabled = false;
			this.tbUserPassword.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.tbUserPassword.Location = new System.Drawing.Point(164, 110);
			this.tbUserPassword.Name = "tbUserPassword";
			this.tbUserPassword.PasswordChar = '*';
			this.tbUserPassword.Size = new System.Drawing.Size(104, 23);
			this.tbUserPassword.TabIndex = 25;
			this.tbUserPassword.Text = "";
			// 
			// label5
			// 
			this.label5.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.label5.Location = new System.Drawing.Point(164, 86);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(104, 16);
			this.label5.TabIndex = 24;
			this.label5.Text = "User password";
			// 
			// tbUserName
			// 
			this.tbUserName.Enabled = false;
			this.tbUserName.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.tbUserName.Location = new System.Drawing.Point(164, 54);
			this.tbUserName.Name = "tbUserName";
			this.tbUserName.Size = new System.Drawing.Size(104, 23);
			this.tbUserName.TabIndex = 23;
			this.tbUserName.Text = "";
			// 
			// label4
			// 
			this.label4.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.label4.Location = new System.Drawing.Point(164, 30);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(104, 16);
			this.label4.TabIndex = 22;
			this.label4.Text = "User name";
			// 
			// tbServerURL
			// 
			this.tbServerURL.Enabled = false;
			this.tbServerURL.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.tbServerURL.Location = new System.Drawing.Point(12, 166);
			this.tbServerURL.Name = "tbServerURL";
			this.tbServerURL.Size = new System.Drawing.Size(384, 23);
			this.tbServerURL.TabIndex = 21;
			this.tbServerURL.Text = "";
			// 
			// label3
			// 
			this.label3.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.label3.Location = new System.Drawing.Point(12, 142);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(104, 16);
			this.label3.TabIndex = 20;
			this.label3.Text = "ServerURL";
			// 
			// tbVisualizationID
			// 
			this.tbVisualizationID.Enabled = false;
			this.tbVisualizationID.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.tbVisualizationID.Location = new System.Drawing.Point(12, 110);
			this.tbVisualizationID.Name = "tbVisualizationID";
			this.tbVisualizationID.Size = new System.Drawing.Size(128, 23);
			this.tbVisualizationID.TabIndex = 19;
			this.tbVisualizationID.Text = "";
			// 
			// label2
			// 
			this.label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.label2.Location = new System.Drawing.Point(12, 86);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(104, 16);
			this.label2.TabIndex = 18;
			this.label2.Text = "Visualization ID";
			// 
			// tbVisualizationTypeID
			// 
			this.tbVisualizationTypeID.Enabled = false;
			this.tbVisualizationTypeID.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.tbVisualizationTypeID.Location = new System.Drawing.Point(12, 54);
			this.tbVisualizationTypeID.Name = "tbVisualizationTypeID";
			this.tbVisualizationTypeID.Size = new System.Drawing.Size(128, 23);
			this.tbVisualizationTypeID.TabIndex = 17;
			this.tbVisualizationTypeID.Text = "";
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.label1.Location = new System.Drawing.Point(12, 30);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(136, 16);
			this.label1.TabIndex = 16;
			this.label1.Text = "Visualization type ID";
			// 
			// GPSMonitorConfigurationForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(416, 219);
			this.Controls.Add(this.tbCrdSysID);
			this.Controls.Add(this.label7);
			this.Controls.Add(this.tbUpdatingInterval);
			this.Controls.Add(this.label6);
			this.Controls.Add(this.tbUserPassword);
			this.Controls.Add(this.label5);
			this.Controls.Add(this.tbUserName);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.tbServerURL);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.tbVisualizationID);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.tbVisualizationTypeID);
			this.Controls.Add(this.label1);
			this.Name = "GPSMonitorConfigurationForm";
			this.Text = "GPSMonitorConfigurationForm";
			this.ResumeLayout(false);

		}
		#endregion
	}
}
